/// <reference types="node" />
import type { Packet, Parser } from 'mqtt-packet';
import net from 'react-native-tcp-socket';
import { EventEmitter } from 'events';
export type Callback = (err?: Error | undefined) => any;
export declare class Client extends EventEmitter {
    protected socket: net.Socket;
    protected parser: Parser;
    protected _opts: Object | undefined;
    constructor(socket: net.Socket, mqttOptions?: Object);
    setKeepAlive(keepalive: number): void;
    setProtocolVersion(version: number): void;
    write(packet: Packet, cb?: Callback | undefined): void;
    end(): void;
    close(): void;
    connect(props?: Object, cb?: Callback | undefined): void;
    connack(props?: Object, cb?: Callback | undefined): void;
    publish(props?: Object, cb?: Callback | undefined): void;
    puback(props?: Object, cb?: Callback | undefined): void;
    pubrec(props?: Object, cb?: Callback | undefined): void;
    pubrel(props?: Object, cb?: Callback | undefined): void;
    pubcomp(props?: Object, cb?: Callback | undefined): void;
    subscribe(props?: Object, cb?: Callback | undefined): void;
    suback(props?: Object, cb?: Callback | undefined): void;
    unsubscribe(props?: Object, cb?: Callback | undefined): void;
    unsuback(props?: Object, cb?: Callback | undefined): void;
    pingreq(props?: Object, cb?: Callback | undefined): void;
    pingresp(props?: Object, cb?: Callback | undefined): void;
    disconnect(props?: Object, cb?: Callback | undefined): void;
}
export declare class Server extends EventEmitter {
    protected server: net.Server;
    protected _opts: Object | undefined;
    constructor(opts?: Object);
    listen(opts: {
        port: number;
        host: string;
        reuseAddress?: boolean;
    }, callback?: Callback): void;
    close(callback?: Callback): void;
}
export default Server;
export { SimpleMQBroker } from './simple-mq';
//# sourceMappingURL=index.d.ts.map